package com.gic.store.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.store.dto.StoreStrategyDTO;

import java.util.List;

/**
 * @author guojx
 * @date 2019/7/4 9:44 AM
 */
public interface StoreStrategyApiService {

    /**
     * 新增 策略数据
     * @param storeStrategyDTO
     * @return
     */
    ServiceResponse<Integer> saveStoreStrategy(StoreStrategyDTO storeStrategyDTO);


    /**
     * 删除分组（单条）
     * @param strategyId
     * @return
     */
    ServiceResponse<Integer> deleteStoreStrategy(int strategyId);

    /**
     * 修改策略
     * @param storeStrategyDTO
     * @return
     */
    ServiceResponse<Integer> modifyStoreStrategy(StoreStrategyDTO storeStrategyDTO);


    /**
     * 根据主键ID获取数据
     * @param strategyId
     * @return
     */
    ServiceResponse<StoreStrategyDTO> getStoreStrategyById(int strategyId);

    /**
     * 置底
     * @param strategyId
     * @return
     */
    ServiceResponse<Integer> sortBottom(int strategyId);

    /**
     * 置顶
     * @param strategyId
     * @return
     */
    ServiceResponse<Integer> sortTopping(int strategyId);

    /**
     * 上移、下移
     * @param strategyId
     * @param isUp
     * @return
     */
    ServiceResponse<Integer> upOrDown(int strategyId, boolean isUp);

    /**
     * 设置排序值
     * @param strategyId
     * @param setValue
     * @return
     */
    ServiceResponse<Integer> setStoreStrategySort(int strategyId, int setValue);

    /**
     * 分页查询分组策略数据
     * @param enterpriseId
     * @param search
     * @param strategyType
     * @param pageNum
     * @param pageSize
     * @return
     */
    ServiceResponse<Page<StoreStrategyDTO>> listStoreField(int enterpriseId, String search, int strategyType, Integer pageNum, Integer pageSize);

    ServiceResponse setStoreGroupStrategyWeight(Integer enterpriseId, int weight);

    ServiceResponse getStoreGroupStrategyWeight(Integer enterpriseId);

    /**
     * 重置门店策略
     * @param regionIdList
     * @param storeStatusList
     * @return
     */
    ServiceResponse resetStoreGroupStrategy(List<Integer> regionIdList, List<Integer> storeStatusList);

}
